import {useRef as $lCpZC$useRef} from "react";
import {useLayoutEffect as $lCpZC$useLayoutEffect} from "@radix-ui/react-use-layout-effect";

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $95af0b826cbc904b$exports = {};

$parcel$export($95af0b826cbc904b$exports, "useBodyPointerEvents", () => $95af0b826cbc904b$export$c78b33423ab8317c);


let $95af0b826cbc904b$var$changeCount = 0;
let $95af0b826cbc904b$var$originalBodyPointerEvents;
function $95af0b826cbc904b$export$c78b33423ab8317c({ disabled: disabled  }) {
    const isTouchOrPenPressedRef = $lCpZC$useRef(false);
    $lCpZC$useLayoutEffect(()=>{
        if (disabled) {
            if ($95af0b826cbc904b$var$changeCount === 0) $95af0b826cbc904b$var$originalBodyPointerEvents = document.body.style.pointerEvents;
            function resetPointerEvents() {
                $95af0b826cbc904b$var$changeCount--;
                if ($95af0b826cbc904b$var$changeCount === 0) document.body.style.pointerEvents = $95af0b826cbc904b$var$originalBodyPointerEvents;
            }
            document.body.style.pointerEvents = 'none';
            $95af0b826cbc904b$var$changeCount++;
            function handlePointerUp(event) {
                isTouchOrPenPressedRef.current = event.pointerType !== 'mouse';
            }
            document.addEventListener('pointerup', handlePointerUp);
            return ()=>{
                if (isTouchOrPenPressedRef.current) /**
           * We force pointer-events to remain disabled until `click` fires on touch devices
           * because browsers implement a ~350ms delay between the time the user stops
           * touching the display and when the browser executes events. We need to ensure we
           * don't reactivate pointer-events within this timeframe otherwise the browser may
           * execute events that should have been prevented.
           *
           * We are aware that `touch-action: manipulation` shortens this delay for events,
           * but it isn't enough to cover all cases.
           *
           * When there is an input on screen:
           * - if a click event is bound to it, it will fire after a `pointerdown` which may
           * have re-enabled pointer-events (regardless of `touch-action: manipulation`).
           * - if clicking it causes the page to zoom, the events will wait for the zoom to
           * finish before executing on the input.
           * - if long pressing it, the events will execute after the longpress delay.
           */ document.addEventListener('click', resetPointerEvents, {
                    once: true
                });
                else resetPointerEvents();
                document.removeEventListener('pointerup', handlePointerUp);
            };
        }
    }, [
        disabled
    ]);
}




export {$95af0b826cbc904b$export$c78b33423ab8317c as useBodyPointerEvents};
//# sourceMappingURL=index.module.js.map
